
/* definition d'un individu */
typedef struct 
{ 
  float fitness; 
  Node *pg; 
 
} individu, * pindividu; 
 
 

/* definition de la classe Pg: Programmation gntique */
class Pg
{
public:
  
  Pg();
  ~Pg(){};
  
  
  void SetPopMax(int p);

  void SetPercSelection(float p);

  void SetPercMutation(float p);
  
  void SetPercCrossover(float p);

  void SetMaxGen(int p);

  void SetMaxFitness(float p);

  void SetProfInit(int p);

  void SetProfExt(int p);

  float MaxFitness();

  pindividu GetSuperIndividu();
  
  void cycle_pg(void); 

private:
  
  virtual Node * creer_arbre(int prof){}; 
 
  virtual void fitness(pindividu pi){};

  pindividu creer_individu(); 

  pindividu clone_pindividu(pindividu p); 
  
  void free_pindividu(pindividu p); 
 
  void aff_prog_gen(pindividu pi) ;

  void quick_sort(pindividu pt[], int bas, int haut); 

  void fitness_population(void) ;

  void mutation_inversion(pindividu p);
 
  void mutation_extension(pindividu p);

  void crossover_2ind(pindividu p1, pindividu p2); 

  void mutation(pindividu t[],int size);
 
  void crossover(); 
  
  void init_population(void); 
 
 // profondeur d'extension d'arbre pour la mutation
  pindividu pop_tab[1000]; 
  // population
  pindividu new_pop_tab[1000]; 
  // nouvelle population
  pindividu superind;
  // super individu

  int pop_max;
  // population max
  float perc_selection; 
  // pourcentage de selection
  float perc_mutation; 
  // pourcentage de mutation
  float perc_crossover;
  // pourcentage de crossover
  int max_gen;
  // nb max de generation
  float max_fitness;
  // maximun de fitness (infini)
  int prof_init;
  // profondeur des arbres de creation d'individu
  int prof_ext;
 
};
