/* Definition d'un noeud d'arbre */

#include <stdio.h>

#include "node.hpp"

 
void Node::free_nodes(Node * n) 
  // libere la structure de noeud
{ 
  if (n->fils != NULL) free_nodes(n->fils); 
  n->~Node();
} 

  
float Node::calc_nb_noeuds(Node * n)
  // calcul le nombre de noeuds de la structure
{ 
  if (n->fils != NULL) return(1+calc_nb_noeuds(n->fils)); else return 0; 
} 
 
Node * Node::pos_node(int pos, Node *n) 
  // retourne le pointeur de noeud  la position n
{ 
  if (pos <=0) return n; 
  return(pos_node(--pos,n->fils)); 
} 
 

